<?php

namespace Drupal\plugin_form_element_test\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a test form for the Plugin form element.
 */
class PluginTestForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'plugin_test_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['plugin'] = [
      '#type' => 'plugin',
      '#title' => $this->t('Configure language condition'),
      '#plugin_manager' => 'plugin.manager.condition',
      '#default_value' => [
        'id' => 'language',
        'configuration' => [],
      ],
    ];

    $form['actions'] = [
      '#type' => 'actions',
      'submit' => [
        '#type' => 'submit',
        '#value' => $this->t('Send'),
      ],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $form_state->cleanValues();

    if (\Drupal::moduleHandler()->moduleExists('devel')) {
      \Drupal::service('devel.dumper')->message($form_state->getValue('plugin'));
    }
    else {
      \Drupal::messenger()->addStatus(print_r($form_state->getValue('plugin'), TRUE));
    }
  }

}
