<?php

namespace Drupal\plugin_form_element_test\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a test form for the Plugins form element.
 */
class PluginsTestForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'plugins_test_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['plugins'] = [
      '#type' => 'plugins',
      '#title' => $this->t('Plugins'),
      '#plugin_manager' => 'plugin.manager.condition',
      '#default_value' => [
        'uuid_1' => ['id' => 'language', 'configuration' => []],
      ],
    ];
    $form['plugins_cardinality'] = [
      '#type' => 'plugins',
      '#title' => $this->t('Plugins with cardinality 2'),
      '#plugin_manager' => 'plugin.manager.condition',
      '#cardinality' => 2,
      '#default_value' => [],
    ];

    $form['actions'] = [
      '#type' => 'actions',
      'submit' => [
        '#type' => 'submit',
        '#value' => $this->t('Send'),
      ],
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $form_state->cleanValues();

    if (\Drupal::moduleHandler()->moduleExists('devel')) {
      \Drupal::service('devel.dumper')->message($form_state->getValue('plugins'));
      \Drupal::service('devel.dumper')->message($form_state->getValue('plugins_cardinality'));
    }
    else {
      \Drupal::messenger()->addStatus(print_r($form_state->getValue('plugins'), TRUE));
      \Drupal::messenger()->addStatus(print_r($form_state->getValue('plugins_cardinality'), TRUE));
    }
  }

}
