<?php

namespace Drupal\plugin_form_element\Element;

use Drupal\Core\Render\Attribute\RenderElement;
use Drupal\Core\Render\Element\Operations;
use Drupal\Core\Render\Element\RenderElementBase;

/**
 * Extends the operations render element to work for with the plugins element.
 */
#[RenderElement('plugins_operations')]
class PluginsOperations extends Operations {

  /**
   * {@inheritdoc}
   */
  public function getInfo() {
    return array_merge([
      '#theme' => 'links__dropbutton__operations__plugins',
    ], parent::getInfo());
  }

  /**
   * {@inheritdoc}
   */
  public static function preRenderDropbutton($element) {
    $element = parent::preRenderDropbutton($element);

    // Attach #ajax events if title is a render array.
    foreach ($element['#links'] as &$link) {
      if (isset($link['title']['#ajax'])) {
        $link['title'] = RenderElementBase::preRenderAjaxForm($link['title']);
      }
    }

    return $element;
  }

}
